Index: GNUmakefile.am
===================================================================
--- GNUmakefile.am	(revision 35758)
+++ GNUmakefile.am	(working copy)
@@ -101,7 +101,8 @@
 	-I$(srcdir)/JavaScriptCore/ForwardingHeaders \
 	-I$(srcdir)/JavaScriptCore/wtf \
 	-I$(srcdir)/JavaScriptCore/kjs \
-	-I$(top_builddir)/DerivedSources
+	-I$(top_builddir)/DerivedSources \
+	-I$(top_builddir)/WebCore/bindings/gdom
 
 # The variables above are already included below so no need to touch
 # these variables unless you really have to
@@ -220,6 +221,7 @@
 
 # WebKit
 webkitgtk_h_api :=
+gdomgtk_h_api :=
 webkitgtk_sources :=
 webkitgtk_cppflags :=
 webkitgtk_built_sources :=
@@ -232,8 +234,13 @@
 libwebkit_1_0_ladir = $(prefix)/include/webkit-1.0/webkit
 libwebkit_1_0_la_HEADERS = \
 	$(webkitgtk_h_api) \
-	WebKit/gtk/webkit/webkitenumtypes.h
+	$(gdomgtk_h_api) \
+	WebKit/gtk/webkit/webkitenumtypes.h \
+	WebKit/gtk/webkit/gdom.h 
 
+#WebKit/gtk/webkit/gdomenumtypes.h
+#WebKit/gtk/webkit/gdomdefines.h
+
 libwebkit_1_0_la_SOURCES = \
 	$(webkitgtk_sources)
 
@@ -304,6 +311,342 @@
 webcore_libadd += -lgstinterfaces-0.10 -lgstvideo-0.10
 endif
 
+WebKit/gtk/webkit/webkitwebframe.h: WebKit/gtk/webkit/GdomDocument.h \
+                                    WebKit/gtk/webkit/GdomXMLHttpRequest.h
+
+WebKit/gtk/webkit/GdomXMLHttpRequest.h: DerivedSources/GdomXMLHttpRequest.h
+	cp DerivedSources/GdomXMLHttpRequest.h WebKit/gtk/webkit/GdomXMLHttpRequest.h
+
+WebKit/gtk/webkit/GdomDocument.h: DerivedSources/GdomDocument.h
+	cp DerivedSources/GdomDocument.h WebKit/gtk/webkit/GdomDocument.h
+
+WebKit/gtk/webkit/GdomDOMObject.h: WebCore/bindings/gdom/GdomDOMObject.h
+	cp WebCore/bindings/gdom/GdomDOMObject.h WebKit/gtk/webkit/GdomDOMObject.h
+
+WebKit/gtk/webkit/GdomEventTargetNode.h: WebCore/bindings/gdom/GdomEventTargetNode.h
+	cp WebCore/bindings/gdom/GdomEventTargetNode.h WebKit/gtk/webkit/GdomEventTargetNode.h
+
+
+gdomgtk_h_api += \
+	WebKit/gtk/webkit/GdomDocument.h\
+	WebKit/gtk/webkit/GdomEventTargetNode.h\
+	WebKit/gtk/webkit/GdomDOMObject.h\
+	DerivedSources/GdomAttr.h\
+	DerivedSources/GdomAttrprops.h\
+	DerivedSources/GdomBarInfo.h\
+	DerivedSources/GdomBarInfoprops.h\
+	DerivedSources/GdomCanvasGradient.h\
+	DerivedSources/GdomCanvasGradientprops.h\
+	DerivedSources/GdomCanvasPattern.h\
+	DerivedSources/GdomCanvasPatternprops.h\
+	DerivedSources/GdomCanvasPixelArray.h\
+	DerivedSources/GdomCanvasPixelArrayprops.h\
+	DerivedSources/GdomCanvasRenderingContext2D.h\
+	DerivedSources/GdomCanvasRenderingContext2Dprops.h\
+	DerivedSources/GdomCDATASection.h\
+	DerivedSources/GdomCDATASectionprops.h\
+	DerivedSources/GdomCharacterData.h\
+	DerivedSources/GdomCharacterDataprops.h\
+	DerivedSources/GdomClipboard.h\
+	DerivedSources/GdomClipboardprops.h\
+	DerivedSources/GdomComment.h\
+	DerivedSources/GdomCommentprops.h\
+	DerivedSources/GdomConsole.h\
+	DerivedSources/GdomConsoleprops.h\
+	DerivedSources/GdomCounter.h\
+	DerivedSources/GdomCounterprops.h\
+	DerivedSources/GdomCSSCharsetRule.h\
+	DerivedSources/GdomCSSCharsetRuleprops.h\
+	DerivedSources/GdomCSSFontFaceRule.h\
+	DerivedSources/GdomCSSFontFaceRuleprops.h\
+	DerivedSources/GdomCSSImportRule.h\
+	DerivedSources/GdomCSSImportRuleprops.h\
+	DerivedSources/GdomCSSMediaRule.h\
+	DerivedSources/GdomCSSMediaRuleprops.h\
+	DerivedSources/GdomCSSPageRule.h\
+	DerivedSources/GdomCSSPageRuleprops.h\
+	DerivedSources/GdomCSSPrimitiveValue.h\
+	DerivedSources/GdomCSSPrimitiveValueprops.h\
+	DerivedSources/GdomCSSRule.h\
+	DerivedSources/GdomCSSRuleList.h\
+	DerivedSources/GdomCSSRuleListprops.h\
+	DerivedSources/GdomCSSRuleprops.h\
+	DerivedSources/GdomCSSStyleDeclaration.h\
+	DerivedSources/GdomCSSStyleDeclarationprops.h\
+	DerivedSources/GdomCSSStyleRule.h\
+	DerivedSources/GdomCSSStyleRuleprops.h\
+	DerivedSources/GdomCSSStyleSheet.h\
+	DerivedSources/GdomCSSStyleSheetprops.h\
+	DerivedSources/GdomCSSValue.h\
+	DerivedSources/GdomCSSValueList.h\
+	DerivedSources/GdomCSSValueListprops.h\
+	DerivedSources/GdomCSSValueprops.h\
+	DerivedSources/GdomCSSVariablesDeclaration.h\
+	DerivedSources/GdomCSSVariablesDeclarationprops.h\
+	DerivedSources/GdomCSSVariablesRule.h\
+	DerivedSources/GdomCSSVariablesRuleprops.h\
+	DerivedSources/GdomDatabase.h\
+	DerivedSources/GdomDatabaseprops.h\
+	DerivedSources/GdomDocumentFragment.h\
+	DerivedSources/GdomDocumentFragmentprops.h\
+	DerivedSources/GdomDocumentprops.h\
+	DerivedSources/GdomDocumentType.h\
+	DerivedSources/GdomDocumentTypeprops.h\
+	DerivedSources/GdomDOMApplicationCache.h\
+	DerivedSources/GdomDOMApplicationCacheprops.h\
+	DerivedSources/GdomDOMCoreException.h\
+	DerivedSources/GdomDOMCoreExceptionprops.h\
+	DerivedSources/GdomDOMImplementation.h\
+	DerivedSources/GdomDOMImplementationprops.h\
+	DerivedSources/GdomDOMParser.h\
+	DerivedSources/GdomDOMParserprops.h\
+	DerivedSources/GdomDOMSelection.h\
+	DerivedSources/GdomDOMSelectionprops.h\
+	DerivedSources/GdomDOMWindow.h\
+	DerivedSources/GdomDOMWindowprops.h\
+	DerivedSources/GdomElement.h\
+	DerivedSources/GdomElementprops.h\
+	DerivedSources/GdomEntity.h\
+	DerivedSources/GdomEntityprops.h\
+	DerivedSources/GdomEntityReference.h\
+	DerivedSources/GdomEntityReferenceprops.h\
+	DerivedSources/GdomEventException.h\
+	DerivedSources/GdomEventExceptionprops.h\
+	DerivedSources/GdomEvent.h\
+	DerivedSources/GdomEventprops.h\
+	DerivedSources/GdomFile.h\
+	DerivedSources/GdomFileList.h\
+	DerivedSources/GdomFileListprops.h\
+	DerivedSources/GdomFileprops.h\
+	DerivedSources/GdomHistory.h\
+	DerivedSources/GdomHistoryprops.h\
+	DerivedSources/GdomHTMLAnchorElement.h\
+	DerivedSources/GdomHTMLAnchorElementprops.h\
+	DerivedSources/GdomHTMLAppletElement.h\
+	DerivedSources/GdomHTMLAppletElementprops.h\
+	DerivedSources/GdomHTMLAreaElement.h\
+	DerivedSources/GdomHTMLAreaElementprops.h\
+	DerivedSources/GdomHTMLBaseElement.h\
+	DerivedSources/GdomHTMLBaseElementprops.h\
+	DerivedSources/GdomHTMLBaseFontElement.h\
+	DerivedSources/GdomHTMLBaseFontElementprops.h\
+	DerivedSources/GdomHTMLBlockquoteElement.h\
+	DerivedSources/GdomHTMLBlockquoteElementprops.h\
+	DerivedSources/GdomHTMLBodyElement.h\
+	DerivedSources/GdomHTMLBodyElementprops.h\
+	DerivedSources/GdomHTMLBRElement.h\
+	DerivedSources/GdomHTMLBRElementprops.h\
+	DerivedSources/GdomHTMLButtonElement.h\
+	DerivedSources/GdomHTMLButtonElementprops.h\
+	DerivedSources/GdomHTMLCanvasElement.h\
+	DerivedSources/GdomHTMLCanvasElementprops.h\
+	DerivedSources/GdomHTMLCollection.h\
+	DerivedSources/GdomHTMLCollectionprops.h\
+	DerivedSources/GdomHTMLDirectoryElement.h\
+	DerivedSources/GdomHTMLDirectoryElementprops.h\
+	DerivedSources/GdomHTMLDivElement.h\
+	DerivedSources/GdomHTMLDivElementprops.h\
+	DerivedSources/GdomHTMLDListElement.h\
+	DerivedSources/GdomHTMLDListElementprops.h\
+	DerivedSources/GdomHTMLDocument.h\
+	DerivedSources/GdomHTMLDocumentprops.h\
+	DerivedSources/GdomHTMLElement.h\
+	DerivedSources/GdomHTMLElementprops.h\
+	DerivedSources/GdomHTMLEmbedElement.h\
+	DerivedSources/GdomHTMLEmbedElementprops.h\
+	DerivedSources/GdomHTMLFieldSetElement.h\
+	DerivedSources/GdomHTMLFieldSetElementprops.h\
+	DerivedSources/GdomHTMLFontElement.h\
+	DerivedSources/GdomHTMLFontElementprops.h\
+	DerivedSources/GdomHTMLFormElement.h\
+	DerivedSources/GdomHTMLFormElementprops.h\
+	DerivedSources/GdomHTMLFrameElement.h\
+	DerivedSources/GdomHTMLFrameElementprops.h\
+	DerivedSources/GdomHTMLFrameSetElement.h\
+	DerivedSources/GdomHTMLFrameSetElementprops.h\
+	DerivedSources/GdomHTMLHeadElement.h\
+	DerivedSources/GdomHTMLHeadElementprops.h\
+	DerivedSources/GdomHTMLHeadingElement.h\
+	DerivedSources/GdomHTMLHeadingElementprops.h\
+	DerivedSources/GdomHTMLHRElement.h\
+	DerivedSources/GdomHTMLHRElementprops.h\
+	DerivedSources/GdomHTMLHtmlElement.h\
+	DerivedSources/GdomHTMLHtmlElementprops.h\
+	DerivedSources/GdomHTMLIFrameElement.h\
+	DerivedSources/GdomHTMLIFrameElementprops.h\
+	DerivedSources/GdomHTMLImageElement.h\
+	DerivedSources/GdomHTMLImageElementprops.h\
+	DerivedSources/GdomHTMLInputElement.h\
+	DerivedSources/GdomHTMLInputElementprops.h\
+	DerivedSources/GdomHTMLIsIndexElement.h\
+	DerivedSources/GdomHTMLIsIndexElementprops.h\
+	DerivedSources/GdomHTMLLabelElement.h\
+	DerivedSources/GdomHTMLLabelElementprops.h\
+	DerivedSources/GdomHTMLLegendElement.h\
+	DerivedSources/GdomHTMLLegendElementprops.h\
+	DerivedSources/GdomHTMLLIElement.h\
+	DerivedSources/GdomHTMLLIElementprops.h\
+	DerivedSources/GdomHTMLLinkElement.h\
+	DerivedSources/GdomHTMLLinkElementprops.h\
+	DerivedSources/GdomHTMLMapElement.h\
+	DerivedSources/GdomHTMLMapElementprops.h\
+	DerivedSources/GdomHTMLMarqueeElement.h\
+	DerivedSources/GdomHTMLMarqueeElementprops.h\
+	DerivedSources/GdomHTMLMenuElement.h\
+	DerivedSources/GdomHTMLMenuElementprops.h\
+	DerivedSources/GdomHTMLMetaElement.h\
+	DerivedSources/GdomHTMLMetaElementprops.h\
+	DerivedSources/GdomHTMLModElement.h\
+	DerivedSources/GdomHTMLModElementprops.h\
+	DerivedSources/GdomHTMLObjectElement.h\
+	DerivedSources/GdomHTMLObjectElementprops.h\
+	DerivedSources/GdomHTMLOListElement.h\
+	DerivedSources/GdomHTMLOListElementprops.h\
+	DerivedSources/GdomHTMLOptGroupElement.h\
+	DerivedSources/GdomHTMLOptGroupElementprops.h\
+	DerivedSources/GdomHTMLOptionElement.h\
+	DerivedSources/GdomHTMLOptionElementprops.h\
+	DerivedSources/GdomHTMLOptionsCollection.h\
+	DerivedSources/GdomHTMLOptionsCollectionprops.h\
+	DerivedSources/GdomHTMLParagraphElement.h\
+	DerivedSources/GdomHTMLParagraphElementprops.h\
+	DerivedSources/GdomHTMLParamElement.h\
+	DerivedSources/GdomHTMLParamElementprops.h\
+	DerivedSources/GdomHTMLPreElement.h\
+	DerivedSources/GdomHTMLPreElementprops.h\
+	DerivedSources/GdomHTMLQuoteElement.h\
+	DerivedSources/GdomHTMLQuoteElementprops.h\
+	DerivedSources/GdomHTMLScriptElement.h\
+	DerivedSources/GdomHTMLScriptElementprops.h\
+	DerivedSources/GdomHTMLSelectElement.h\
+	DerivedSources/GdomHTMLSelectElementprops.h\
+	DerivedSources/GdomHTMLStyleElement.h\
+	DerivedSources/GdomHTMLStyleElementprops.h\
+	DerivedSources/GdomHTMLTableCaptionElement.h\
+	DerivedSources/GdomHTMLTableCaptionElementprops.h\
+	DerivedSources/GdomHTMLTableCellElement.h\
+	DerivedSources/GdomHTMLTableCellElementprops.h\
+	DerivedSources/GdomHTMLTableColElement.h\
+	DerivedSources/GdomHTMLTableColElementprops.h\
+	DerivedSources/GdomHTMLTableElement.h\
+	DerivedSources/GdomHTMLTableElementprops.h\
+	DerivedSources/GdomHTMLTableRowElement.h\
+	DerivedSources/GdomHTMLTableRowElementprops.h\
+	DerivedSources/GdomHTMLTableSectionElement.h\
+	DerivedSources/GdomHTMLTableSectionElementprops.h\
+	DerivedSources/GdomHTMLTextAreaElement.h\
+	DerivedSources/GdomHTMLTextAreaElementprops.h\
+	DerivedSources/GdomHTMLTitleElement.h\
+	DerivedSources/GdomHTMLTitleElementprops.h\
+	DerivedSources/GdomHTMLUListElement.h\
+	DerivedSources/GdomHTMLUListElementprops.h\
+	DerivedSources/GdomImageData.h\
+	DerivedSources/GdomImageDataprops.h\
+	DerivedSources/GdomJavaScriptCallFrame.h\
+	DerivedSources/GdomJavaScriptCallFrameprops.h\
+	DerivedSources/GdomKeyboardEvent.h\
+	DerivedSources/GdomKeyboardEventprops.h\
+	DerivedSources/GdomLocation.h\
+	DerivedSources/GdomLocationprops.h\
+	DerivedSources/GdomMediaList.h\
+	DerivedSources/GdomMediaListprops.h\
+	DerivedSources/GdomMessageEvent.h\
+	DerivedSources/GdomMessageEventprops.h\
+	DerivedSources/GdomMimeTypeArray.h\
+	DerivedSources/GdomMimeTypeArrayprops.h\
+	DerivedSources/GdomMimeType.h\
+	DerivedSources/GdomMimeTypeprops.h\
+	DerivedSources/GdomMouseEvent.h\
+	DerivedSources/GdomMouseEventprops.h\
+	DerivedSources/GdomMutationEvent.h\
+	DerivedSources/GdomMutationEventprops.h\
+	DerivedSources/GdomNamedNodeMap.h\
+	DerivedSources/GdomNamedNodeMapprops.h\
+	DerivedSources/GdomNavigator.h\
+	DerivedSources/GdomNavigatorprops.h\
+	DerivedSources/GdomNodeFilter.h\
+	DerivedSources/GdomNodeFilterprops.h\
+	DerivedSources/GdomNode.h\
+	DerivedSources/GdomNodeIterator.h\
+	DerivedSources/GdomNodeIteratorprops.h\
+	DerivedSources/GdomNodeList.h\
+	DerivedSources/GdomNodeListprops.h\
+	DerivedSources/GdomNodeprops.h\
+	DerivedSources/GdomNotation.h\
+	DerivedSources/GdomNotationprops.h\
+	DerivedSources/GdomOverflowEvent.h\
+	DerivedSources/GdomOverflowEventprops.h\
+	DerivedSources/GdomPluginArray.h\
+	DerivedSources/GdomPluginArrayprops.h\
+	DerivedSources/GdomPlugin.h\
+	DerivedSources/GdomPluginprops.h\
+	DerivedSources/GdomProcessingInstruction.h\
+	DerivedSources/GdomProcessingInstructionprops.h\
+	DerivedSources/GdomProgressEvent.h\
+	DerivedSources/GdomProgressEventprops.h\
+	DerivedSources/GdomRangeException.h\
+	DerivedSources/GdomRangeExceptionprops.h\
+	DerivedSources/GdomRange.h\
+	DerivedSources/GdomRangeprops.h\
+	DerivedSources/GdomRect.h\
+	DerivedSources/GdomRectprops.h\
+	DerivedSources/GdomScreen.h\
+	DerivedSources/GdomScreenprops.h\
+	DerivedSources/GdomSQLError.h\
+	DerivedSources/GdomSQLErrorprops.h\
+	DerivedSources/GdomSQLResultSet.h\
+	DerivedSources/GdomSQLResultSetprops.h\
+	DerivedSources/GdomSQLResultSetRowList.h\
+	DerivedSources/GdomSQLResultSetRowListprops.h\
+	DerivedSources/GdomSQLTransaction.h\
+	DerivedSources/GdomSQLTransactionprops.h\
+	DerivedSources/GdomStorageEvent.h\
+	DerivedSources/GdomStorageEventprops.h\
+	DerivedSources/GdomStorage.h\
+	DerivedSources/GdomStorageprops.h\
+	DerivedSources/GdomStyleSheet.h\
+	DerivedSources/GdomStyleSheetList.h\
+	DerivedSources/GdomStyleSheetListprops.h\
+	DerivedSources/GdomStyleSheetprops.h\
+	DerivedSources/GdomTextEvent.h\
+	DerivedSources/GdomTextEventprops.h\
+	DerivedSources/GdomText.h\
+	DerivedSources/GdomTextprops.h\
+	DerivedSources/GdomTreeWalker.h\
+	DerivedSources/GdomTreeWalkerprops.h\
+	DerivedSources/GdomUIEvent.h\
+	DerivedSources/GdomUIEventprops.h\
+	DerivedSources/GdomWebKitAnimationEvent.h\
+	DerivedSources/GdomWebKitAnimationEventprops.h\
+	DerivedSources/GdomWebKitCSSTransformValue.h\
+	DerivedSources/GdomWebKitCSSTransformValueprops.h\
+	DerivedSources/GdomWebKitTransitionEvent.h\
+	DerivedSources/GdomWebKitTransitionEventprops.h\
+	DerivedSources/GdomWheelEvent.h\
+	DerivedSources/GdomWheelEventprops.h\
+	DerivedSources/GdomXMLHttpRequestException.h\
+	DerivedSources/GdomXMLHttpRequestExceptionprops.h\
+	DerivedSources/GdomXMLHttpRequest.h\
+	DerivedSources/GdomXMLHttpRequestProgressEvent.h\
+	DerivedSources/GdomXMLHttpRequestProgressEventprops.h\
+	DerivedSources/GdomXMLHttpRequestprops.h\
+	DerivedSources/GdomXMLHttpRequestUpload.h\
+	DerivedSources/GdomXMLHttpRequestUploadprops.h\
+	DerivedSources/GdomXMLSerializer.h\
+	DerivedSources/GdomXMLSerializerprops.h\
+	DerivedSources/GdomXPathEvaluator.h\
+	DerivedSources/GdomXPathEvaluatorprops.h\
+	DerivedSources/GdomXPathException.h\
+	DerivedSources/GdomXPathExceptionprops.h\
+	DerivedSources/GdomXPathExpression.h\
+	DerivedSources/GdomXPathExpressionprops.h\
+	DerivedSources/GdomXPathNSResolver.h\
+	DerivedSources/GdomXPathNSResolverprops.h\
+	DerivedSources/GdomXPathResult.h\
+	DerivedSources/GdomXPathResultprops.h\
+	DerivedSources/GdomXSLTProcessor.h\
+	DerivedSources/GdomXSLTProcessorprops.h
+
 webkitgtk_h_api += \
 	WebKit/gtk/webkit/webkit.h \
 	WebKit/gtk/webkit/webkitdefines.h \
@@ -315,12 +658,17 @@
 	WebKit/gtk/webkit/webkitwebsettings.h \
 	WebKit/gtk/webkit/webkitwebview.h
 
+# WebKit/gtk/webkit/webkitgdomdefines.h
+
 webkitgtk_built_sources += \
 	DerivedSources/webkitenumtypes.cpp \
 	DerivedSources/webkitmarshal.cpp \
 	DerivedSources/webkitmarshal.h \
 	WebKit/gtk/webkit/webkitenumtypes.h
 
+#	DerivedSources/gdomenumtypes.cpp 
+#	WebKit/gtk/webkit/gdomenumtypes.h
+
 webkitgtk_sources += \
 	WebKit/gtk/WebCoreSupport/ChromeClientGtk.cpp \
 	WebKit/gtk/WebCoreSupport/ChromeClientGtk.h \
@@ -344,7 +692,9 @@
 	WebKit/gtk/webkit/webkitwebframe.cpp \
 	WebKit/gtk/webkit/webkitwebhistoryitem.cpp \
 	WebKit/gtk/webkit/webkitwebsettings.cpp \
-	WebKit/gtk/webkit/webkitwebview.cpp
+	WebKit/gtk/webkit/webkitwebview.cpp \
+	WebKit/gtk/webkit/webkitevent.cpp  \
+	WebKit/gtk/webkit/webkitevent.h 
 
 webkitgtk_cppflags += \
 	-DBUILDING_WEBKIT \
@@ -366,6 +716,9 @@
 	stamp-webkitenumtypes.cpp \
 	stamp-webkitenumtypes.h
 
+#	stamp-gdomenumtypes.cpp 
+#	stamp-gdomenumtypes.h 
+
 WEBKIT_MARSHAL = $(GENSOURCES)/webkitmarshal
 WEBKIT_MARSHAL_LIST = $(WEBKIT_MARSHAL).list
 
@@ -442,6 +795,54 @@
 	&& cp xgen-gtc $@ \
 	&& rm -f xgen-gtc
 
+WebKit/gtk/webkit/gdomenumtypes.h: stamp-gdomenumtypes.h
+	@true
+stamp-gdomenumtypes.h: $(gdomgtk_h_api) GNUmakefile
+	(cd $(srcdir) \
+	&& glib-mkenums \
+			--fhead "#ifndef GDOM_ENUM_TYPES_H\n" \
+			--fhead "#define GDOM_ENUM_TYPES_H\n\n" \
+			--fhead "#include <glib-object.h>\n\n" \
+			--fhead "G_BEGIN_DECLS\n\n" \
+			--ftail "G_END_DECLS\n\n" \
+			--ftail "#endif\n" \
+			--fprod "#include <@filename@>\n\n" \
+			--eprod "#define GDOM_TYPE_@ENUMSHORT@ @enum_name@_get_type()\n\n" \
+			--eprod "WEBKIT_API GType\n@enum_name@_get_type(void);\n\n" \
+			$(gdomgtk_h_api) | \
+			sed 's,WebKit/gtk/,,' | \
+		sed 's,web_kit,gdom,' | \
+		sed 's,GDOM_TYPE_KIT,GDOM_TYPE,' \
+		) > xgen-cgth \
+	&& (cmp -s xgen-cgth WebKit/gtk/webkit/gdomenumtypes.h || cp xgen-cgth WebKit/gtk/webkit/gdomenumtypes.h) \
+	&& rm -f xgen-cgth \
+	&& echo timestamp > $(@F)
+
+#              --fhead "#include <webkit/gdomdefines.h>\n\n" 
+
+DerivedSources/gdomenumtypes.cpp: $(gdomgtk_h_api) GNUmakefile
+	(cd $(srcdir) \
+	&& glib-mkenums \
+			--fhead "#include <config.h>\n" \
+			--fhead "#include <glib-object.h>\n" \
+			--fhead "#include \"$(top_builddir)/WebKit/gtk/webkit/gdomenumtypes.h\"\n\n" \
+			--fhead "extern \"C\" {\n\n" \
+			--fprod "\n/* enumerations from \"@filename@\" */" \
+			--vhead "static const G@Type@Value _@enum_name@_values[] = {" \
+			--vprod "    { @VALUENAME@, \"@VALUENAME@\", \"@valuenick@\" }," \
+			--vtail "    { 0, NULL, NULL }\n};\n\n" \
+			--vtail "GType @enum_name@_get_type(void)\n{\n" \
+			--vtail "    static GType type = 0;\n\n" \
+			--vtail "    if (!type)\n" \
+			--vtail "        type = g_@type@_register_static(\"@EnumName@\", _@enum_name@_values);\n\n" \
+			--vtail "    return type;\n}\n\n" \
+			--ftail "}\n" \
+		$(gdomgtk_h_api) | \
+		sed 's,web_kit,gdom,' \
+		) > xgen-cgtc \
+	&& cp xgen-cgtc $@ \
+	&& rm -f xgen-cgtc
+
 # END WEBKIT GTK+
 #
 # Files that will be distributed
Index: WebKit/gtk/webkit/webkitwebframe.cpp
===================================================================
--- WebKit/gtk/webkit/webkitwebframe.cpp	(revision 36015)
+++ WebKit/gtk/webkit/webkitwebframe.cpp	(working copy)
@@ -1,11 +1,13 @@
 /*
  * Copyright (C) 2007, 2008 Holger Hans Peter Freyther
+ * Copyright (C) 2008 Luke Kenneth Casson Leighton <lkcl@lkcl.net>
  * Copyright (C) 2007 Alp Toker <alp@atoker.com>
  * Copyright (C) 2007 Apple Inc.
  * Copyright (C) 2008 Christian Dywan <christian@imendio.com>
  * Copyright (C) 2008 Collabora Ltd.
  * Copyright (C) 2008 Nuanti Ltd.
  *
+ *
  * This library is free software; you can redistribute it and/or
  * modify it under the terms of the GNU Library General Public
  * License as published by the Free Software Foundation; either
@@ -42,6 +44,15 @@
 #include "RenderTreeAsText.h"
 #include "JSDOMBinding.h"
 #include "ScriptController.h"
+#include "GdomDocument.h"
+#include "GdomXMLHttpRequest.h"
+#include "GDOMObject.h"
+#include "PrivateIntGdomXMLHttpRequest.h"
+#include "PrivateGdomXMLHttpRequest.h"
+#include "PrivateIntGdomDocument.h"
+#include "PrivateGdomDocument.h"
+#include "GdomEvent.h"
+#include "EventListenerWindow.h"
 
 #include <JavaScriptCore/APICast.h>
 
@@ -49,6 +60,11 @@
 using namespace WebCore;
 using namespace std;
 
+namespace WebCore {
+	gpointer toGDOM(Document* doc);
+	gpointer toGDOM(XMLHttpRequest* obj);
+}
+
 extern "C" {
 
 enum {
@@ -57,6 +73,7 @@
     LOAD_DONE,
     TITLE_CHANGED,
     HOVERING_OVER_LINK,
+    BROWSER_EVENT,
     LAST_SIGNAL
 };
 
@@ -162,6 +179,16 @@
             G_TYPE_NONE, 2,
             G_TYPE_STRING, G_TYPE_STRING);
 
+    webkit_web_frame_signals[BROWSER_EVENT] = g_signal_new("browser-event",
+            G_TYPE_FROM_CLASS(frameClass),
+            (GSignalFlags)(G_SIGNAL_RUN_LAST | G_SIGNAL_ACTION),
+            0,
+            NULL,
+            NULL,
+            webkit_marshal_VOID__OBJECT_BOOLEAN,
+            G_TYPE_NONE, 2,
+            GDOM_TYPE_EVENT, G_TYPE_BOOLEAN);
+
     /*
      * implementations of virtual methods
      */
@@ -294,6 +321,112 @@
 }
 
 /**
+ * webkit_web_frame_get_xml_http_request:
+ * @frame: a #WebKitWebFrame
+ *
+ * returns a Gdom wrapper around an XMLHttpRequest
+ *
+ * Return value: a GdomXMLHttpRequest
+ */
+GdomXMLHttpRequest* webkit_web_frame_get_xml_http_request(WebKitWebFrame* frame)
+{
+    g_return_val_if_fail(WEBKIT_IS_WEB_FRAME(frame), NULL);
+
+    //WebKitWebFramePrivate* priv = frame->priv;
+
+    Frame* coreFrame = core(frame);
+    ASSERT(coreFrame);
+	return GDOM_XML_HTTP_REQUEST(WebCore::toGDOM(XMLHttpRequest::create(coreFrame->document()).get()));
+}
+
+/**
+ * webkit_web_frame_create_xhtml_dom_document:
+ * @frame: a #WebKitWebFrame
+ *
+ * returns a Gdom wrapper around a new Document, XHTML formatted
+ *
+ * Return value: a GdomDocument
+ */
+GdomDocument* webkit_web_frame_create_xhtml_dom_document(WebKitWebFrame* frame)
+{
+    g_return_val_if_fail(WEBKIT_IS_WEB_FRAME(frame), NULL);
+
+    //WebKitWebFramePrivate* priv = frame->priv;
+
+    Frame* coreFrame = core(frame);
+    ASSERT(coreFrame);
+	PassRefPtr<Document> doc = Document::createXHTML(coreFrame);
+	return GDOM_DOCUMENT(WebCore::toGDOM(doc.get()));
+}
+
+/**
+ * webkit_web_frame_create_dom_document:
+ * @frame: a #WebKitWebFrame
+ *
+ * returns a Gdom wrapper around a new Document 
+ *
+ * Return value: a GdomDocument
+ */
+GdomDocument* webkit_web_frame_create_dom_document(WebKitWebFrame* frame)
+{
+    g_return_val_if_fail(WEBKIT_IS_WEB_FRAME(frame), NULL);
+
+    //WebKitWebFramePrivate* priv = frame->priv;
+
+    Frame* coreFrame = core(frame);
+    ASSERT(coreFrame);
+	PassRefPtr<Document> doc = Document::create(coreFrame);
+	return GDOM_DOCUMENT(WebCore::toGDOM(doc.get()));
+}
+
+/**
+ * webkit_web_frame_get_dom_document:
+ * @frame: a #WebKitWebFrame
+ *
+ * returns a Gdom wrapper around a Document 
+ *
+ * Return value: a GdomDocument
+ */
+GdomDocument* webkit_web_frame_get_dom_document(WebKitWebFrame* frame)
+{
+    g_return_val_if_fail(WEBKIT_IS_WEB_FRAME(frame), NULL);
+
+    //WebKitWebFramePrivate* priv = frame->priv;
+
+    Frame* coreFrame = core(frame);
+    ASSERT(coreFrame);
+	return GDOM_DOCUMENT(WebCore::toGDOM(coreFrame->document()));
+}
+
+/* XXX TODO: make this not take frame* as an argument,
+ * and make it return a GdomEventListener class */
+extern "C" {
+WEBKIT_API gboolean
+add_window_event_listener(WebKitWebFrame* wf, Frame *frame, const char *name);
+}
+
+/**
+ * webkit_web_frame_add_event_listener:
+ * @frame: a #WebKitWebFrame
+ *
+ * adds an event listener to the frame's document
+ *
+ * Return value: the name of @frame
+ */
+gboolean webkit_web_frame_add_event_listener(WebKitWebFrame* frame,
+                                             const gchar* event_type)
+{
+    g_return_val_if_fail(WEBKIT_IS_WEB_FRAME(frame), FALSE);
+
+    //WebKitWebFramePrivate* priv = frame->priv;
+
+    Frame* coreFrame = core(frame);
+    ASSERT(coreFrame);
+
+	return add_window_event_listener(frame, coreFrame, event_type);
+}
+
+/**
  * webkit_web_frame_get_name:
  * @frame: a #WebKitWebFrame
  *
Index: WebKit/gtk/webkit/EventListenerNode.h
===================================================================
--- WebKit/gtk/webkit/EventListenerNode.h	(revision 0)
+++ WebKit/gtk/webkit/EventListenerNode.h	(revision 0)
@@ -0,0 +1,40 @@
+/*
+ * Copyright (C) 2008 Luke Kenneth Casson Leighton <lkcl@lkcl.net>
+ *
+ * This library is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU Library General Public
+ * License as published by the Free Software Foundation; either
+ * version 2 of the License, or (at your option) any later version.
+ *
+ * This library is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * Library General Public License for more details.
+ *
+ * You should have received a copy of the GNU Library General Public License
+ * along with this library; see the file COPYING.LIB.  If not, write to
+ * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
+ * Boston, MA 02110-1301, USA.
+ */
+
+
+#ifndef JS_DOM_EVENT_LISTENER_NODE_H
+#define JS_DOM_EVENT_LISTENER_NODE_H
+
+#include <glib.h>
+#include <webkit/webkitdefines.h>
+
+
+#include "GdomEventTargetNode.h"
+
+/* TODO: return the actual event listener created, which requires
+ * a glib wrapper object to be created.
+ * TODO: provide a 'remove_event_listener' which takes that glib
+ * object as an argument */
+extern "C" {
+WEBKIT_API
+gboolean add_event_listener(GdomEventTargetNode *wf, const char *name,
+                            gboolean useCapture);
+}
+
+#endif /*JS_DOM_EVENT_LISTENER_NODE_H */
Index: WebKit/gtk/webkit/webkitwebframe.h
===================================================================
--- WebKit/gtk/webkit/webkitwebframe.h	(revision 36015)
+++ WebKit/gtk/webkit/webkitwebframe.h	(working copy)
@@ -1,6 +1,7 @@
 /*
  * Copyright (C) 2007 Holger Hans Peter Freyther
  * Copyright (C) 2007 Alp Toker <alp@atoker.com>
+ * Copyright (C) 2008 Luke Kenneth Casson Leighton <lkcl@lkcl.net>
  *
  * This library is free software; you can redistribute it and/or
  * modify it under the terms of the GNU Library General Public
@@ -26,6 +27,8 @@
 
 #include <webkit/webkitdefines.h>
 #include <webkit/webkitnetworkrequest.h>
+#include <webkit/GdomDocument.h>
+#include <webkit/GdomXMLHttpRequest.h>
 
 G_BEGIN_DECLS
 
@@ -61,6 +64,18 @@
 WEBKIT_API WebKitWebFrame *
 webkit_web_frame_new                (WebKitWebView        *web_view);
 
+WEBKIT_API GdomXMLHttpRequest *
+webkit_web_frame_get_xml_http_request       (WebKitWebFrame       *frame);
+
+WEBKIT_API GdomDocument *
+webkit_web_frame_get_dom_document       (WebKitWebFrame       *frame);
+
+WEBKIT_API GdomDocument *
+webkit_web_frame_create_dom_document       (WebKitWebFrame       *frame);
+
+WEBKIT_API GdomDocument *
+webkit_web_frame_create_xhtml_dom_document       (WebKitWebFrame       *frame);
+
 WEBKIT_API WebKitWebView *
 webkit_web_frame_get_web_view       (WebKitWebFrame       *frame);
 
@@ -93,6 +108,10 @@
 WEBKIT_API JSGlobalContextRef
 webkit_web_frame_get_global_context (WebKitWebFrame       *frame);
 
+WEBKIT_API gboolean
+webkit_web_frame_add_event_listener(WebKitWebFrame* frame,
+                                     const gchar          *name);
+
 G_END_DECLS
 
 #endif
Index: WebKit/gtk/webkit/EventListenerWindow.h
===================================================================
--- WebKit/gtk/webkit/EventListenerWindow.h	(revision 0)
+++ WebKit/gtk/webkit/EventListenerWindow.h	(revision 0)
@@ -0,0 +1,32 @@
+/*
+ * Copyright (C) 2008 Luke Kenneth Casson Leighton <lkcl@lkcl.net>
+ *
+ * This library is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU Library General Public
+ * License as published by the Free Software Foundation; either
+ * version 2 of the License, or (at your option) any later version.
+ *
+ * This library is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * Library General Public License for more details.
+ *
+ * You should have received a copy of the GNU Library General Public License
+ * along with this library; see the file COPYING.LIB.  If not, write to
+ * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
+ * Boston, MA 02110-1301, USA.
+ */
+
+
+#ifndef JS_DOM_EVENT_LISTENER_WINDOW_H
+#define JS_DOM_EVENT_LISTENER_WINDOW_H
+
+#include <glib.h>
+#include <webkit/webkitdefines.h>
+
+
+extern "C" {
+/* TODO: make a GdomEventListener class, to be returned here */
+}
+
+#endif /*JS_DOM_EVENT_LISTENER_WINDOW_H */
Index: WebKit/gtk/webkit/EventListenerXMLHttpRequest.h
===================================================================
--- WebKit/gtk/webkit/EventListenerXMLHttpRequest.h	(revision 0)
+++ WebKit/gtk/webkit/EventListenerXMLHttpRequest.h	(revision 0)
@@ -0,0 +1,40 @@
+/*
+ * Copyright (C) 2008 Luke Kenneth Casson Leighton <lkcl@lkcl.net>
+ *
+ * This library is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU Library General Public
+ * License as published by the Free Software Foundation; either
+ * version 2 of the License, or (at your option) any later version.
+ *
+ * This library is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * Library General Public License for more details.
+ *
+ * You should have received a copy of the GNU Library General Public License
+ * along with this library; see the file COPYING.LIB.  If not, write to
+ * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
+ * Boston, MA 02110-1301, USA.
+ */
+
+
+#ifndef JS_DOM_EVENT_LISTENER_XML_HTTP_REQUEST_H
+#define JS_DOM_EVENT_LISTENER_XML_HTTP_REQUEST_H
+
+#include <glib.h>
+#include <webkit/webkitdefines.h>
+
+
+#include "GdomXMLHttpRequest.h"
+
+/* TODO: return the actual event listener created, which requires
+ * a glib wrapper object to be created.
+ * TODO: provide a 'remove_event_listener' which takes that glib
+ * object as an argument */
+extern "C" {
+WEBKIT_API
+gboolean add_xml_http_request_event_listener(GdomXMLHttpRequest *wf,
+               const char *name);
+}
+
+#endif /*JS_DOM_EVENT_LISTENER_XML_HTTP_REQUEST_H */
